Couch=function(texture, width, height, depth, space ,x,y,z){
	var self=this
	
	this.setChildren=function(){
		this.assise=new Box(this.space,0,0, this.width-this.space, this.height/3, this.depth, this.texture)
		this.assise.name="assise"
		
		this.accoudoir_left=new Box(0,0,0, this.space, this.height*2/3, this.depth, this.texture)
		this.accoudoir_left.name="accoudoir left"
		
		this.accoudoir_right=new Box(this.width,0,0, this.space, this.height*2/3, this.depth, this.texture)
		this.accoudoir_right.name="accoudoir right"
		
		this.dossier=new Box(0,0,0, this.width-this.space, this.height, this.space, this.texture)
		this.dossier.setTransformOrigin('center','bottom')
		this.dossier.move(this.space,0,5,5,0,0)
		this.dossier.name="dossier"
		
		this.addObject(this.assise)
		this.addObject(this.accoudoir_left)
		this.addObject(this.accoudoir_right)
		this.addObject(this.dossier)
	}
	
	//width, height, depth : largeur et hauteur d'une case. space : espace d'un mur
	this.init=function(texture=texture_null, width=400, height=200, depth=150, space=30,x=0,y=0,z=0){
		Object3D.call(this, x, y, z);
		this.width=width
		this.height=height
		this.depth=depth
		this.collidable=false
		this.space=space
		this.texture=texture;
		this.setChildren();
		this.type="Couch"
		this.name="Couch"
		this.wrap.className+=" couch"
	}
	
	this.init(texture, width, height, depth, space ,x,y,z)
}

Table=function(texture, width, height, depth, space, width_foot ,x,y,z){
	var self=this
	
	this.setChildren=function(){
		this.plateau=new Box(0,this.height,0, this.width, this.space, this.depth, this.texture)
		this.plateau.name="plateau"
		
		this.pied1=new Box(this.width_foot,0,this.width_foot, this.width_foot, this.height, this.width_foot, this.texture)
		this.pied1.name="pied1"

		this.pied2=new Box(this.width-2*this.width_foot,0,this.width_foot, this.width_foot, this.height, this.width_foot, this.texture)
		this.pied2.name="pied2"

		this.pied3=new Box(this.width-2*this.width_foot,0,this.depth-2*this.width_foot, this.width_foot, this.height, this.width_foot, this.texture)
		this.pied3.name="pied3"

		this.pied4=new Box(this.width_foot,0,this.depth-2*this.width_foot, this.width_foot, this.height, this.width_foot, this.texture)
		this.pied4.name="pied4"
				
		this.addObject(this.plateau)
		this.addObject(this.pied1)
		this.addObject(this.pied2)
		this.addObject(this.pied3)
		this.addObject(this.pied4)
	}
	
	//width, height, depth : largeur et hauteur d'une case. space : espace d'un mur
	this.init=function(texture=texture_null, width=350, height=100, depth=150, space=8,width_foot=10, x=0,y=0,z=0){
		Object3D.call(this, x, y, z);
		this.width=width
		this.height=height
		this.depth=depth
		this.width_foot=width_foot
		this.collidable=false
		this.space=space
		this.texture=texture;
		this.setChildren();
		this.type="Table"
		this.name="Table"
		this.wrap.className+=" Table"
	}
	this.init(texture, width, height, depth, space,width_foot,x,y,z)
}

Laptop=function(width, height, space ,x,y,z){
	var self=this
	
	this.setChildren=function(){
				
		this.texture_laptop=new Texture({'background-image':'linear-gradient(to right, #505050, #6a6a6a 10%, #6a6a6a 60%, #505050 80%)', 'border':'solid #505050 1px'});
		this.texture_keyboard_top=new Texture({'background-image':"url('images/keyboard.png')",'background-size':'100% 100%', 'background-repeat': 'no-repeat'})
		this.texture_screen_front=new Texture({'background-image':"url('images/screen.png')",'background-size':'100% 100%', 'background-repeat': 'no-repeat'})

		
		this.texture_keyboard={top:this.texture_keyboard_top, bottom:false, left:this.texture_laptop, right:this.texture_laptop, back:this.texture_laptop, front:this.texture_laptop}
		this.texture_screen={top:this.texture_laptop, bottom:false, left:this.texture_laptop, right:this.texture_laptop, back:this.texture_laptop, front:this.texture_screen_front}
		
		this.keyboard=new Box(0,0,0, this.width, this.space, this.height, this.texture_keyboard)
		this.keyboard.name="keyboard"
		
		this.screen=new Box(0,0,0, this.width, this.height, this.space, this.texture_screen)
		this.screen.setTransformOrigin(this.width/2,this.space)
		this.screen.move(0, this.space/2, this.height - 2*this.space, -8, 0, 0)
		this.screen.name="screen"
		
		this.addObject(this.screen)
		this.addObject(this.keyboard)
	}
	
	this.init=function(width=100, height=70, space=5, x=0,y=0,z=0){
		Object3D.call(this, x, y, z);
		this.width=width
		this.height=height
		this.collidable=false
		this.space=space
		this.setChildren();
		this.type="Laptop"
		this.name="Laptop"
		this.wrap.className+=" Laptop"
	}
	this.init(width, height, space,x,y,z)
}


Bureau=function(texture, width, height, depth, space, width_foot , space_top, x,y,z){
	var self=this
		
	this.setChildren2=function(){
		this.plateau_top=new Box(0,this.height,0, this.width, this.space, this.depth, this.texture)
		this.plateau_top.name="plateau_top"

		this.plateau_left=new Box(0,this.height - this.space_top,0, this.space, this.space_top, this.depth, this.texture)
		this.plateau_left.name="plateau_left"

		this.plateau_right=new Box(this.width - this.space, this.height - this.space_top,0, this.space, this.space_top, this.depth, this.texture)
		this.plateau_right.name="plateau_right"
						
		this.addObject(this.plateau_top)
		this.addObject(this.plateau_left)
		this.addObject(this.plateau_right)
	}
	
	//width, height, depth : largeur et hauteur d'une case. space : espace d'un mur
	this.init=function(texture=texture_null, width=350, height=140, depth=150, space=8,width_foot=10, space_top=20, x=0,y=0,z=0){
		Table.call(this, texture, width, height - space_top - space, depth, space, width_foot ,x,y,z);
		this.setChildren();
		this.height=height;
		this.space_top=space_top;
		this.setChildren2();
		this.type="Desk"
		this.name="Desk"
		this.wrap.className+=" Desk"
	}
	this.init(texture, width, height, depth, space,width_foot,space_top,x,y,z)
}


Bibliotheque=function(texture, width, height, depth, space, N_planches ,x,y,z){
	var self=this
	
	this.setChildren=function(){
		
		this.planche_gauche=new Box(0,0,0, this.space, this.height, this.depth, this.texture)
		this.planche_gauche.name="planche_gauche"
		this.addObject(this.planche_gauche)

		this.planche_droite=new Box(this.width-this.space,0,0, this.space, this.height, this.depth, this.texture)
		this.planche_droite.name="planche_droite"
		this.addObject(this.planche_droite)

		this.planche_fond=new Rectangle(0,0, this.depth, this.width, this.height, this.texture)
		this.planche_fond.name="planche_fond"
		this.addObject(this.planche_fond)
		
		this.etageres=[]
		var espace_entre_etageres=(this.height - (this.N_planches+2)*this.space)/(this.N_planches+1)
		
		for(var i=0;i<this.N_planches+2;i++){
			this.etageres.push(new Box(this.space, i*(espace_entre_etageres + this.space),0, this.width-2*this.space, this.space, this.depth, this.texture))
			this.etageres[i].name="etagere"
			this.addObject(this.etageres[i])
		}
				
		this.addObject(this.planche_gauche)
		this.addObject(this.planche_droite)
		this.addObject(this.planche_fond)
	}
	
	this.init=function(texture=texture_null, width=350, height=100, depth=150, space=8,N_planches=6, x=0,y=0,z=0){
		Object3D.call(this, x, y, z);
		this.width=width
		this.height=height
		this.depth=depth
		this.N_planches=N_planches
		this.collidable=false
		this.space=space
		this.texture=texture;
		this.setChildren();
		this.type="bib"
		this.name="bib"
		this.wrap.className+=" bib"
	}
	this.init(texture, width, height, depth, space,N_planches,x,y,z)
}

Cadre=function(texture, img, width, height, depth, space ,x,y,z){
	var self=this
	
	this.setChildren=function(){
		
		this.planche_bas=new Box(0,0,0, this.width, this.space, this.depth, this.texture)
		this.planche_bas.name="planche_bas"
		this.addObject(this.planche_bas)

		this.planche_haut=new Box(0,this.height-this.space,0, this.width, this.space, this.depth, this.texture)
		this.planche_haut.name="planche_haut"
		this.addObject(this.planche_haut)

		this.planche_gauche=new Box(0,this.space,0, this.space, this.height-2*this.space, this.depth, this.texture)
		this.planche_gauche.name="planche_gauche"
		this.addObject(this.planche_gauche)

		this.planche_droite=new Box(this.width-this.space,this.space,0, this.space, this.height-2*this.space, this.depth, this.texture)
		this.planche_droite.name="planche_droite"
		this.addObject(this.planche_droite)

		if(this.img){
			this.texture_image=new Texture(img)
			this.image=new Rectangle(this.space,this.space, this.depth, this.width-2*this.space, this.height-2*this.space, this.texture_image)
			this.image.name="image"
			this.addObject(this.image)
		}
		
	}
	
	this.init=function(texture=texture_null, img, width=350, height=100, depth=150, space=8, x=0,y=0,z=0){
		Object3D.call(this, x, y, z);
		this.width=width
		this.height=height
		this.depth=depth
		this.img=img
		this.collidable=false
		this.space=space
		this.texture=texture;
		this.setChildren();
		this.type="Cadre"
		this.name="cadre"
		this.wrap.className+=" cadre"
	}
	this.init(texture, img, width, height, depth, space,x,y,z)
}

Livres=function(width, height, depth, texture_tranches, texture_left, texture_right, faces, x,y,z){
	var self=this
	
	this.setChildren=function(){
		
		
		
		this.planche_bas=new Box(0,0,0, this.width, this.space, this.depth, this.texture)
		this.planche_bas.name="planche_bas"
		this.addObject(this.planche_bas)

		this.planche_haut=new Box(0,this.height-this.space,0, this.width, this.space, this.depth, this.texture)
		this.planche_haut.name="planche_haut"
		this.addObject(this.planche_haut)

		this.planche_gauche=new Box(0,this.space,0, this.space, this.height-2*this.space, this.depth, this.texture)
		this.planche_gauche.name="planche_gauche"
		this.addObject(this.planche_gauche)

		this.planche_droite=new Box(this.width-this.space,this.space,0, this.space, this.height-2*this.space, this.depth, this.texture)
		this.planche_droite.name="planche_droite"
		this.addObject(this.planche_droite)

		if(this.img){
			this.texture_image=new Texture(img)
			this.image=new Rectangle(this.space,this.space, this.depth, this.width-2*this.space, this.height-2*this.space, this.texture_image)
			this.image.name="image"
			this.addObject(this.image)
		}
		
	}
	
	this.init=function(width, height, depth, texture_tranches, texture_left, texture_right, faces={'front':true, 'bottom':true, 'top':true, 'back':true, 'left':true, 'right':true}, x=0,y=0,z=0){
		this.texture_tranches=texture_tranches
		this.texture_left=texture_left
		this.texture_right=texture_right
		this.faces=faces
		this.texture={}
		var texture_tranche=new Texture({'url':'images/side-pages-books-line.png', 'background-size':'contain', 'background-repeat': 'repeat'})
		if(this.faces.front){
			this.texture.front=new Texture(this.texture_tranches)			
		}
		
		if(this.faces.left&& this.texture_left){
			this.texture.left=new Texture(this.texture_left)
		}
		if(this.faces.right && this.texture_right){
			this.texture.right=new Texture(this.texture_right)
		}
		
		if(this.faces.back){
			this.texture.back=texture_tranche
		}
		
		if(this.faces.top){
			this.texture.top=texture_tranche
		}
		if(this.faces.bottom){
			this.texture.bottom=texture_tranche
		}
		
		Box.call(this, x,y,z,width, height, depth, this.texture);
		this.width=width
		this.height=height
		this.depth=depth
		
		this.collidable=false

		this.type="Livres"
		this.name="Livres"
		this.wrap.className+=" livres"
	}
	this.init(width, height, depth, texture_tranches, texture_left, texture_right, faces, x,y,z)
}


PorteManteau=function(x,y,z, width, height, thickness){
	var self=this
	
	this.setChildren=function(){		
		this.colonne=new Sprite(-this.thickness*0.5,this.height*0.1, 0, this.thickness, this.height*0.9, 'images/porte-manteau/colonne-porte-manteau.png')
		this.colonne.name="colonne"
		this.addObject(this.colonne)

		this.pied1=new Rectangle(0,0,0, this.width, this.height*0.3, 'images/porte-manteau/pied-porte-manteau.png')
		this.pied1.setTransformOrigin('right', 'center')
		this.pied1.move(-this.width-this.thickness*0.3,0,0)
		this.addObject(this.pied1)

		this.pied2=new Rectangle(0,0,0, this.width, this.height*0.3, 'images/porte-manteau/pied-porte-manteau.png')
		this.pied2.setTransformOrigin('center', 'center')
		this.pied2.move(this.thickness*0.3,0,0,0,180,0)
		this.addObject(this.pied2)

		this.pied3=new Rectangle(0,0,0, this.width, this.height*0.3, 'images/porte-manteau/pied-porte-manteau.png')
		this.pied3.setTransformOrigin('left', 'center')
		this.pied3.move(0,0,-this.width-this.thickness*0.3,0,90,0)
		this.addObject(this.pied3)
		
		this.pied4=new Rectangle(0,0,0, this.width, this.height*0.3, 'images/porte-manteau/pied-porte-manteau.png')
		this.pied4.setTransformOrigin('left', 'center')
		this.pied4.move(0,0,this.width+this.thickness*0.3,0,-90,0)
		this.addObject(this.pied4)
		
		this.cercle_bas=new Rectangle(0,0,0,this.width,this.width,'images/porte-manteau/anneau-porte-manteau.png')
		this.cercle_bas.setTransformOrigin('center', 'center')
		this.cercle_bas.move(-this.width/2,this.height*0.001,0,-90,0,0)
		this.addObject(this.cercle_bas)
		
		var r=this.width*1.1
		this.cercle_milieu=new Rectangle(0,0,0,r,r,'images/porte-manteau/anneau-porte-manteau.png')
		this.cercle_milieu.setTransformOrigin('center', 'center')
		this.cercle_milieu.move(-r/2,this.height*0.215,0,-90,0,0)
		this.addObject(this.cercle_milieu)
		
		var h=this.height*0.8
		this.s1=new Rectangle(0,0,0, this.width, this.height*0.15, 'images/porte-manteau/s-porte-manteau.png')
		this.s1.setTransformOrigin('right', 'center')
		this.s1.move(-this.width-this.thickness*0.4,h,0)
		this.addObject(this.s1)

		this.s2=new Rectangle(0,0,0, this.width, this.height*0.15, 'images/porte-manteau/s-porte-manteau.png')
		this.s2.setTransformOrigin('center', 'center')
		this.s2.move(this.thickness*0.4,h,0,0,180,0)
		this.addObject(this.s2)

		this.s3=new Rectangle(0,0,0, this.width, this.height*0.15, 'images/porte-manteau/s-porte-manteau.png')
		this.s3.setTransformOrigin('left', 'center')
		this.s3.move(0,h,-this.width-this.thickness*0.4,0,90,0)
		this.addObject(this.s3)
		
		this.s4=new Rectangle(0,0,0, this.width, this.height*0.15, 'images/porte-manteau/s-porte-manteau.png')
		this.s4.setTransformOrigin('left', 'center')
		this.s4.move(0,h,this.width+this.thickness*0.4,0,-90,0)
		this.addObject(this.s4)

		// var r=this.width*0.8
		// this.cercle_haut=new Rectangle(0,0,0,r,r,'images/porte-manteau/anneau-porte-manteau.png')
		// this.cercle_haut.setTransformOrigin('center', 'center')
		// this.cercle_haut.move(-r/2,this.height*0.8,0,-90,0,0)
		// this.addObject(this.cercle_haut)
		
	}
	
	this.init=function(x=0,y=0,z=0, width=60, height=400, thickness=13){
		Object3D.call(this, x, y, z);
		this.width=width
		this.height=height
		this.thickness=thickness
		this.collidable=false
		this.setChildren();
		this.type="PorteManteau"
		this.name="PorteManteau"
		this.wrap.className+=" PorteManteau"
	}
	this.init(x,y,z, width, height, thickness)
}


Chimney=function(texture, texture_atre, width, height, depth, space ,x,y,z){
	var self=this
	
	this.setChildren=function(){
		
		this.socle=new Box(0,0,0, this.width, this.space, this.depth, this.texture)
		this.socle.name="socle"
		this.addObject(this.socle)

		this.atre=new Rectangle(this.space,this.space,this.depth, this.width - 2*this.space, this.height - 2*this.space, this.texture_atre)
		this.atre.name="atre"
		this.addObject(this.atre)

		this.bord_left=new Box(this.space, this.space, this.space, this.space, this.height - 3*this.space, this.depth - this.space, this.texture)
		this.bord_left.name="bord_left"
		this.addObject(this.bord_left)

		this.bord_right=new Box(this.width - 2*this.space, this.space, this.space, this.space, this.height - 3*this.space, this.depth - this.space, this.texture)
		this.bord_right.name="bord_right"
		this.addObject(this.bord_right)

		this.bord_top=new Box(10, this.height - 2*this.space, 10, this.width - 20, this.space*2, this.depth - 10, this.texture)
		this.bord_top.name="bord_top"
		this.addObject(this.bord_top)
		
		this.tuyau=new Box(0,0,0,  this.width/2, this.height*2, this.depth - this.space, this.texture )
		this.tuyau.name="tuyau de poele !"
		this.tuyau.setTransformOrigin('center','bottom')
		this.tuyau.move(this.width/4, this.height, this.space - 20, -5, 0, 0)
		this.addObject(this.tuyau)
	}	
	
	this.init=function(texture=texture_null, texture_atre=texture_null, width=350, height=300, depth=150, space=25, x=0,y=0,z=0){
		Object3D.call(this, x, y, z);
		this.width=width
		this.height=height
		this.depth=depth
		this.collidable=false
		this.space=space
		this.texture=texture;
		this.texture_atre=texture_atre;
		this.setChildren();
		this.type="Cadre"
		this.name="cadre"
		this.wrap.className+=" cadre"
	}
	this.init(texture, texture_atre, width, height, depth, space,x,y,z)
}

